#include<iostream>
#include<cstdio>
#include<vector>

using namespace std;

const int N = 200+1;
const int base = 1e4;

inline void print(const vector<int>& v){
    if(v.empty()){
        printf("0");
        return;
    }
    printf("%d", v[v.size()-1]);
    for(int i = v.size()-2; i >= 0; --i)
        printf("%04d", v[i]);
}
inline void println(const vector<int>& v){
    print(v);
    printf("\n");
}

inline void norm(vector<int>& v){
    int carry = 0;
    for(int i = 0; i < v.size() || carry; ++i){
        if(i == v.size())
            v.push_back(0);
        carry += v[i];
        v[i] = carry % base;
        carry /= base;
    }
}

inline void operator+=(vector<int>& a, const vector<int> b){
    if(a.size() < b.size())
        a.resize(b.size());
    for(int i = 0; i < b.size(); ++i)
        a[i] += b[i];
    norm(a);
}
inline void operator*=(vector<int>& a, int b){
    for(int i = 0; i < a.size(); ++i)
        a[i] *= b;
    norm(a);
}
inline vector<int> operator*(const vector<int>& a, const vector<int>& b){
    vector<int> res(a.size() + b.size() - 1);
    for(int i = 0; i < a.size(); ++i)
        for(int j = 0; j < b.size(); ++j)
            res[i+j] += a[i]*b[j];
    norm(res);
    return res;
}

vector<int> d[N][N];
inline void init(){
    d[0][0] = vector<int>(1, 1);
    for(int i = 0; i < N; ++i)
        d[i][0] = d[0][i] = vector<int>(1, 1);
    for(int i = 1; i < N; ++i)
        for(int j = 1; j < N; ++j){
            d[i][j] += d[i][j-1];
            d[i][j] += d[i-1][j];
        }
}
inline vector<int> c(int n, int k){
    return d[n-k][k];
}
inline vector<int> factfact(int n){
    vector<int> ans(1, 1);
    for(int i = n; i > 1; i -= 2)
        ans *= i;
    return ans;
}
inline vector<int> pow(vector<int> a, int s){
    vector<int> ans(1, 1);
    while(s){
        if(s&1)
            ans = ans*a;
        a = a*a;
        s >>= 1;
    }
    return ans;
}

int n;
int a[N];

bool used[N];
int cnt[N];
inline void cycles(){
    for(int i = 0; i < n; ++i){
        if(used[i])
            continue;
        used[i] = true;
        int len = 1;
        for(int j = a[i]-1; j != i; j = a[j]-1){
            used[j] = true;
            ++len;
        }
        ++cnt[len];
    }
}

int main(){
    freopen("sleep2.in", "r", stdin);
    freopen("sleep2.out", "w", stdout);
    init();
    scanf("%d", &n);
    for(int i = 0; i < n; ++i)
        scanf("%d", &a[i]);
    cycles();
    vector<int> ans(1, 1);
    for(int i = 2; i <= n; i += 2){
        if(cnt[i]%2){
            printf("0\n");
            return 0;
        }
        ans = ans*factfact(cnt[i]-1)*pow(vector<int>(1, i), cnt[i]/2);
    }
    for(int i = 1; i <= n; i += 2){
        vector<int> sum(1, 1);
        for(int j = 2; j <= cnt[i]; j += 2)
            sum += c(cnt[i], j)*factfact(j-1)*pow(vector<int>(1, i), j/2);
        ans = ans*sum;
    }
    println(ans);
}
