/* GCC */
#include <iostream>
#include <stdio.h>
#include <fstream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <string.h>

using namespace std;

typedef vector<int> bignum;

bignum Norm(bignum a)
{
    int d=0;
    for (int i=0; i<a.size() || d; i++){
        d += a[i];
        a[i] = d%10;
        d /= 10;
    }
    while ((a.size() > 1) && (a.back() == 0)) a.pop_back();
    return a;
}

bignum operator +(bignum a, bignum b)
{
    for (int i=0; i<max(a.size(), b.size()); i++){
        if (i == a.size()) a.push_back(0);
        a[i] += (i < b.size()) ? b[i] : 0;
    }
    a = Norm(a);
    return a;
}

bignum operator *(bignum a, bignum b)
{
    bignum c(1), s;
    for (int i=0; i<a.size(); i++){
        for (int j=0; j<b.size(); j++){
            s.push_back(a[i]*b[j]);
            s = Norm(s);
            c = s + c;
        }
    }
    c = Norm(c);
    return c;
}

bignum Cnk(int n, int k)
{
    bignum res;
    if (n == 1){
        if (k == 0 || k == 1) res = vector<int>(1, 1);
        else res = vector<int>(1, 0);
        return res;
    }
    if (k > n){
        res = vector<int>(1, 0);
        return res;
    }
    res = Cnk(n-1, k-1) + Cnk(n-1, k);
    return res;
}

vector<int> permut;
vector<int> cycle_type;

// Pnn

bignum power(int a, int n)
{
    vector<int> A(1, 1);
    vector<int> B(1, a);
    while (n > 1){
        B = B*B;
        if (n%2 != 0) B = B*A;
        n /= 2;
    }
    return B;
}

int main(void)
{
/*
    bignum a(20), b(15); /// 34567273545347382836 745692659659468  + =  34568019238007042304
                         /// 3456727354 74569  * =  257764702060426
    char c;
    for (int i=10-1; i>=0; i--) { cin >> c; a[i] = c-'0';  }
    //cin >> c;
    for (int i=5-1; i>=0; i--) { cin >> c; b[i] = c-'0';  }

    for (int i=a.size()-1; i>=0; i--) cout << a[i]; cout << "\n0\n";
    for (int i=b.size()-1; i>=0; i--) cout << b[i]; cout << "\n0";
    //return 0;

    bignum sum = a + b;
    bignum mul = a * b;
    for (int i=mul.size()-1; i>=0; i--) cout << mul[i]; cout << "\n";
    return 0;
*/

    ifstream fin("sleep2.in");

    int n, p;
    fin >> n;
    for (int i=0; i<n; i++){
        fin >> p;
        permut.push_back(p-1);
    }

    fin.close();

    bignum answer(1, 0);

    ofstream fout("sleep2.out");

    for (int i=0; i<answer.size(); i++) fout << answer[i];
    fout << "\n";

    fout.close();

    return 0;
}


























