/* GCC */
#include <bits/stdc++.h>
using namespace std;
typedef vector<int> big;
int base = 1000000000;
int n;
vector<int> permutation;
vector<int> cycle(102, 0);

big operator*(big a, big b)
{
    big c(a.size() + b.size(), 0);

    for(int i = 0; i < a.size(); i++)
    {
        long long carry = 0;
        long long res;
        for(int j = 0; j < b.size() || carry; j++)
        {
            if(j < b.size())
                res = (long long)a[i] * (long long)b[i] + (long long)carry + (long long)c[i + j];
            else
                res = (long long)carry + (long long)c[i + j];
            c[i + j] = res % base;
            carry = res / base;
        }
    }

    while(c.size() > 1 && c.back() == 0)
        c.pop_back();
    return c;
}

big operator*(big a, int b)
{
    big c(a.size() + 120, 0);
    long long carry = 0;
    long long res;

    for(int i = 0; i < a.size(); i++)
    {
        if(i < a.size())
            res = (long long)a[i] * (long long)b + (long long)carry + (long long)c[i];
        else
            res = (long long)carry + (long long)c[i];
        c[i] = res % base;
        carry = res / base;
    }

    while(c.size() > 1 && c.back() == 0)
        c.pop_back();
    return c;
}

big operator+(big a, big b)
{
    big c(a.size() + b.size(), 0);
    long long carry = 0;
    long long res;

    for(int i = 0; i < max(a.size(), b.size()) || carry; i++)
    {
        if(i < a.size() && i < b.size())
            res = (long long)a[i] + (long long)b[i] + (long long)carry;
        else if(i < a.size())
            res = (long long)carry + (long long)a[i];
        else if(i < b.size())
            res = (long long)carry + (long long)b[i];
        else
            res = carry;

        c[i] = res % base;
        carry = res / base;
    }

    while(c.size() > 1 && c.back() == 0)
        c.pop_back();
    return c;
}

void CountCycle()
{
    for(int i = 0; i < n; i++)
    {
        if(permutation[i] == -1)
            continue;

        int len = 0;
        int pos = i;
        while(permutation[pos] != -1)
        {
            len++;
            int to = permutation[pos];
            permutation[pos] = -1;
            pos = to;
        }

        cycle[len]++;
    }
}

big pow_(int a, int b)
{
    big num(1, 1);
    big power(1, a);

    while(b)
    {
        if(b & 1)
            num = num * power;
        power = power * power;
        b /= 2;
    }
    return num;
}

big C[102][102];

big Cnk(int n, int k)
{
    if(C[n][k].empty())
    {
        if(k == n || k == 0)
            return big(1, 1);
        C[n][k] = Cnk(n - 1, k) + Cnk(n - 1, k - 1);
    }
    return C[n][k];
}

vector<big> f(1, big(1, 1));

big fact(int a)
{
    a/= 2;
    for(int i = f.size(); i <= a; i++)
    {
        f.push_back(f.back());
        f[i] = f[i] * (2 * i + 1);
    }

    return f[a];
}

void print(big a)
{
    printf("%d", a.back());
    for(int i = a.size() - 2; i >= 0; i--)
        printf("%09d", a[i]);
}

big solve()
{
    big ans(1, 1);
    for(int i = 1; i <= n; i++)
    {
        int N = cycle[i];
        if(N == 0)
            continue;
        big num(1, 1);
        if(i & 1)
        {
            for(int j = 1; j <= N / 2; j++)
                num = num + pow_(i, j) * Cnk(N, j * 2) * fact(2 * j - 1);
        }
        else
        {
            if(N & 1)
                return big(1, 0);
            num = pow_(i, N / 2) * fact(N - 1);
        }
        ans = ans * num;
    }

    return ans;
}

int main()
{
    freopen("sleep2.in", "r", stdin);
    freopen("sleep2.out", "w", stdout);
    cin>> n;
    permutation.resize(n);

    for(int i = 0; i < n; i++)
    {
        cin>> permutation[i];
        permutation[i]--;
    }

    CountCycle();
    print(solve());
    cout<< "\n";

    return 0;
}
