/* GCC */
#include <bits/stdc++.h>

using namespace std;

typedef vector<int> big;

void norm(big& a){
    int i = 0;
    while (i < (int)a.size()){
        if (a[i] > 9){
            if (i+1==(int)a.size()) a.push_back(0);
            a[i+1] += a[i]/10;
            a[i]%=10;
        }
        i++;
    }
    while (a.size()>1 && a.back()==0) a.pop_back();
}

big operator+(const big& a, const big& b){
    big c(max(a.size(), b.size())+1, 0);
    for (int i = 0; i < (int)c.size(); i++){
        c[i] += (i < (int)a.size())? a[i] : 0;
        c[i] += (i < (int)b.size())? b[i] : 0;
    }
    norm(c);
    return c;
}

big operator*(const big& a, const big& b){
    big c(a.size()+b.size(), 0);
    for (int i = 0; i < (int)a.size(); i++){
        for (int j = 0; j < (int)b.size(); j++){
            c[i+j] += a[i]*b[j];
        }
    }
    norm(c);
    return c;
}

big Cnk[101][101];

big& C(int n, int k){
    if (Cnk[n][k].empty()){
        if (k==n || k==0){
            Cnk[n][k].assign(1, 1);
        } else {
            Cnk[n][k] = C(n-1, k-1)+C(n-1, k);
        }
    }
    return Cnk[n][k];
}

vector<big> F(1, big(1, 1));

big& Fnn(int n){
    n/=2;
    if (n >= (int)F.size()){
        for (int i = F.size(); i <= n; i++){
            F.push_back(F.back());
            for (int j = 0; j < (int)F.back().size(); j++){
                F.back()[j] *= 2*i+1;
            }
            norm(F.back());
        }
    }
    return F[n];
}

vector<int> perm;
vector<int> c_count;

void readData(){
    int n;
    scanf("%d", &n);
    for (int i = 0; i < n; i++){
        int p;
        scanf("%d", &p);
        perm.push_back(p-1);
    }
}

void find_c_count(){
    c_count = vector<int>(perm.size()+1, 0);
    for (int i = 0; i < (int)perm.size(); i++){
        if (perm[i] >= 0){
            int c = 0;
            int j = i;
            while (perm[j] >= 0){
                c++;
                int k = perm[j];
                perm[j] = -1;
                j = k;
            }
            c_count[c]++;
        }
    }
}

void fileOut(const big& ans){
    for (int i = ans.size()-1; i >= 0; i--){
        printf("%d", ans[i]);
    }
    printf("\n");
}

big Pow(int a, int n){
    big A(1, 1);
    big B(1, a);
    norm(B);
    while (n > 0){
        if (n&1){
            A = A*B;
            B = B*B;
        } else {
            B = B*B;
        }
        n/=2;
    }
    return A;
}

big solve(){
    big ans(1, 1);
    for (int i = 1; i < (int)c_count.size(); i++){
        big tmp(1, 1);
        if (i&1){
            for (int j = 1; j*2 <= c_count[i]; j++){
                tmp = tmp+Pow(i, j)*Fnn(2*j-1)*C(c_count[i], 2*j);
            }
        } else {
            if (c_count[i]&1){
                tmp = big(1, 0);
            } else {
                tmp = Pow(i, c_count[i]/2)*Fnn(c_count[i]-1);
            }
        }
        ans = ans*tmp;
    }
    return ans;
}

int main(){
	freopen("sleep2.in", "r", stdin);
	freopen("sleep2.out", "w", stdout);
    readData();
    find_c_count();
    fileOut(solve());
    return 0;
}






































